unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ImgList, Thunderbird_Intf;

type
  TForm2 = class(TForm)
    od: TOpenDialog;
    Button1: TButton;
    Button2: TButton;
    List: TListView;
    ImageList: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListDblClick(Sender: TObject);
  private
    FTR: TThunderbirdReader;
    procedure Analyze(AFilename: string);
  public
  end;

var
  Form2: TForm2;

implementation

uses MsgDlg, Email_Defs;

{$R *.dfm}

procedure TForm2.Analyze(AFilename: string);
var
  i: Integer;
  s: string;
begin
  Screen.Cursor:=crHourglass;
  try
    FTR.Clear;
    FTR.LoadFromFile(AFilename);
    List.Items.Clear;
    for i:=0 to FTR.MessageCount-1 do
      with List.Items.Add, FTR.MessageInfos[i] do begin
        if Flags and mifRead=mifRead then
          ImageIndex:=4
        else
          ImageIndex:=5;
        Caption:=ID;
        SubItems.Add(IntToStr(i));
        if Flags and mifAttachment=mifAttachment then
          SubItems.Add('Yes')
        else
          SubItems.Add('');
        case Priority of
          1: SubItems.Add('High');
          5: SubItems.Add('Low');
          else
            SubItems.Add('');
        end;
        if Flags and mifFlag=mifFlag then
          SubItems.Add('Yes')
        else
          SubItems.Add('');
        if SenderName='' then
          s:=SenderEmail
        else
          s:=SenderName;
        SubItems.Add(s);
        SubItems.Add(Subject);
        if ReceivedDate=0 then
          SubItems.Add(Received)
        else
          SubItems.Add(DateTimeToStr(ReceivedDate));
        SubItems.Add(Format('%1.0n',[Size/1]));
        SubItems.Add(IntToStr(i));
      end;
    Caption:=Format('Mozilla Thunderbird Viewer - %d records',[FTR.MessageCount]);
  finally
    Screen.Cursor:=crDefault;
  end;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  if not od.Execute then
    Exit;
  Analyze(od.FileName);
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  FTR:=TThunderbirdReader.Create;
end;

procedure TForm2.ListDblClick(Sender: TObject);
var
  s: string;
  idx: Integer;
begin
  if not Assigned(List.Selected) then
    Exit;
  Screen.Cursor:=crHourglass;
  try
    idx:=StrToInt(List.Selected.SubItems[List.Selected.SubItems.Count-1]);
    s:=FTR.Messages[idx];
  finally
    Screen.Cursor:=crDefault;
  end;
  DisplayMessage(s);
end;

end.
